"use strict";
exports.__esModule = true;
var React = require("react");
var parseChildren = function (children) {
    switch (typeof children) {
        case 'number':
        case 'string':
            return children;
        default:
            if (Array.isArray(children)) {
                return children.map(function (item) { return renderTemplate(item); });
            }
            return null;
    }
};
var parseNode = function (node) { return node; };
var parseAttrs = function (attrs) { return attrs; };
var renderTemplate = function (_a) {
    var node = _a[0], attrs = _a[1], children = _a[2];
    return React.createElement(parseNode(node), parseAttrs(attrs), parseChildren(children));
};
exports.createComponentFactory = function (compiler) { return function (template) {
    var templateFunction = compiler(template);
    return function (props) { return renderTemplate(templateFunction(props)); };
}; };
